<?php
class ModelExtensionPaymentXpaymentStripe extends Model {
    private function getParams($placeholder, $replacer) {
        $this->load->model('extension/payment/xpayment');
        $config = array(
            'returnURL'          => '{returnURL}',
            'storeName'          => '{storeName}',
            'orderTotal'         => '{orderTotal}',
            'currencyCode'       => '{currencyCode}',
            'publicKey'          => '{publicKey}',
            'privateKey'         => '{privateKey}',
            'orderId'            => '{orderId}',
            'firstName'          => '{firstName}',
            'lastName'           => '{lastName}',
            'fullName'           => '{fullName}',
            'email'              => '{email}',
            'streetAddress1'     => '{streetAddress1}',
            'streetAddress2'     => '{streetAddress2}',
            'city'               => '{city}',
            'stateCode'          => '{stateCode}',
            'zipcode'            => '{zipcode}',
            'countryCode'        => '{countryCode}'
        );
        $config = $this->model_extension_payment_xpayment->getParam($config, $placeholder, $replacer);
        return $config;
    }
    public function _xSuccess($placeholder, $replacer) {
        $config = $this->getParams($placeholder, $replacer);
        require_once( DIR_SYSTEM."library/stripe-php/init.php");
        $xdata = array();
        $xdata["amount"] = intval((float)$config["orderTotal"] * 100);
        $xdata["currency"] = $config['currencyCode'];
        $private_key = $config['privateKey'];
        $xdata["source"] = isset($this->request->post['stripeToken']) ? $this->request->post['stripeToken'] : '';
        $xoption = array();
        //$xoption['idempotency_key'] = substr(sha1($config['orderId'] . $config['orderTotal'] . $config['currencyCode']), 0, 16);

        \Stripe\Stripe::setApiKey($private_key);

        $data = array();
        try {
            $charge = \Stripe\Charge::create($xdata, $xoption);
            if ($charge['status'] == 'succeeded') {
                $data['status'] = 'succeeded';
            }
        } catch(Exception $e) {
            $data['error'] = $e->getMessage();
        }
        return $data;
    }
    public function _xInstruction($instruction, $placeholder, $replacer) {
        $config = $this->getParams($placeholder, $replacer);
        $amount = intval((float)$config["orderTotal"] * 100);
        $stripe = '<form action="'.$config["returnURL"].'" method="POST">
          <script
            src="https://checkout.stripe.com/checkout.js" class="stripe-button"
            data-key="'.$config["publicKey"].'"
            data-amount="'.$amount.'"
            data-name="'.$config["storeName"].'"
            data-image="https://stripe.com/img/documentation/checkout/marketplace.png"
            data-locale="auto"
            data-currency="'.$config['currencyCode'].'"
            data-zip-code="false">
          </script>
        </form>
        <style> 
            #button-confirm {display: none;} 
            .quick-checkout-payment button.stripe-button-el {
                visibility: hidden !important;
            }
        </style>
        <script>
            $(document).on("click", ".stripe-button-el", function() {
                failedPostProcessing();
                $(".journal-loading-overlay").hide();
            });
        </script>
        ';
        $instruction .= $stripe;
        return $instruction;
    }
}